
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>mongodb 配置文件解释(转) / 憋错料</title>

    <meta name="description" content="mongodb 配置文件解释(转) Mongodb 3.x配置说明,本文内容忽略了Enterprise版和一些不常用的配置. 一.配置说明 在Mongod安装包中,包含2个进程启动文件:mongod和mongos:其中mongd是核心基础进程,用来接收读写请求.负责存储实际数据,mongod实例是构成集群的基本单位,比如Replication set.Sharding Cluster.Config Servers等:mongos是Sharding Cluster架构模式中的&quot;路由&quot;进程,即客户端请求访问mong ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">mongodb 配置文件解释(转)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>Mongodb 3.x配置说明，本文内容忽略了Enterprise版和一些不常用的配置。</p>
<p><strong>一、配置说明</strong></p>
<p>在Mongod安装包中，包含2个进程启动文件：mongod和mongos；其中mongd是核心基础进程，用来接收读写请求、负责存储实际数据，mongod实例是构成集群的基本单位，比如Replication set、Sharding Cluster、Config Servers等；mongos是Sharding Cluster架构模式中的“路由”进程，即客户端请求访问mongos，然后有mongos将请求转发给合适的sharding server执行操作，并将result返回给客户端，所以mongos基本不存储数据，只是在内存中缓存部分shard key与sharding server的对应关系，便于路由。</p>
<p>在配置文件方面，mongod和mongos有很多相同之处，下文中如有区别之处将会特别指出。</p>
<p>在一个节点上，通常同时启动mongod和mongos进程是正常的，他们之间不存在资源竞争，但是为了避免冲突，我们希望它们使用各自的配置文件，比如mongod.conf、mongos.conf；mongodb的某些平台下的安装包中没有自带配置文件，需要开发者自己创建。</p>
<p>重要配置参数讲解如下：</p>
<p><strong>1、processManagement:</strong></p>
<p>fork: &lt;true | false&gt;</p>
<p>描述：是否以fork模式运行mongod/mongos进程，默认为false。</p>
<p>pidFilePath:&lt;路径&gt;</p>
<p>描述：配合"fork:true"参数，将mongod/mongos进程ID写入指定的文件，如果不指定，将不会创建PID文件。</p>
<p><strong>2、net:</strong></p>
<p>bindIp: &lt;127.0.0.1&gt;</p>
<p>描述：mongod/monogs进程绑定的IP，application通过此IP、port建立链接。可以绑定在任意网卡接口上，如果你的mongos/mongod只需要内网访问，可以绑定在内网IP(例如：192.168.1.100)，如果需要外网访问，那么则绑定外网IP，如果此值为“0.0.0.0”，则绑定到所有接口即内网、外网IP均可以访问。（不建议）可以绑定都多个ip上，ip地址之间用“,”分割。</p>
<p>port: 27017</p>
<p>描述：mongod/mongos侦听端口，默认为27017；不过因为mongodb有2种典型的架构模式：replica set和sharding，如果开发者在一个节点上部署多个mongod实例，需要注意修改此端口以避免冲突。</p>
<p>maxIncomingConnections: 65536</p>
<p>描述：mongod/mongos进程允许的最大连接数，如果此值超过操作系统配置的连接数阀值，将不会生效(ulimit)；默认值为65536。通常客户端将会使用连接池机制，可以有效的控制每个客户端的链接个数。</p>
<p>wireObjectCheck: true</p>
<p>描述：当客户端写入数据时，mongos/mongod是否检测数据的有效性(BSON)，如果数据格式不良，此insert、update操作将会被拒绝；默认值为true</p>
<p>ipv6: false</p>
<p>描述：是否支持mongos/mongod多个实例之间使用IPV6网络，默认值为false。此值需要在整个cluster中保持一致。</p>
<p><strong>3、storage:</strong></p>
<p>dbPath: db</p>
<p>描述：mongod进程存储数据目录，此配置仅对mongod进程有效。默认值为：/data/db。</p>
<p>indexBuildRetry: true</p>
<p>描述：当构建索引时mongod意外关闭，那么再次启动是否重新构建索引；索引构建失败，mongod重启后将会删除尚未完成的索引，但是否重建由此参数决定。默认值为true。</p>
<p>repairPath: _tmp</p>
<p>描述：配合--repair启动命令参数，在repair期间使用此目录存储临时数据，repair结束后此目录下数据将被删除，此配置仅对mongod进程有效。不建议在配置文件中配置，而是使用mongod启动命令指定。</p>
<p>engine: mmapv1</p>
<p>描述：存储引擎类型，mongodb 3.0之后支持“mmapv1”、“wiredTiger”两种引擎，默认值为“mmapv1”；官方宣称wiredTiger引擎更加优秀。</p>
<p>journal:</p>
<p>enabled: true</p>
<p>描述：是否开启journal日志持久存储，journal日志用来数据恢复，是mongod最基础的特性，通常用于故障恢复。64位系统默认为true，32位默认为false，建议开启，仅对mongod进程有效。</p>
<p>directoryPerDB: false</p>
<p>描述：是否将不同DB的数据存储在不同的目录中，dbPath的子目录，目录名为db的名称。对已经存储数据的mongod修改此值，需要首先使用mongodump指令将数据导出，然后关闭mongod，再修改此值和指定新的dbPath，然后使用mongorestore指令重新导入数据。（即导出数据，并使用mongorestore将数据重新写入mongod的新目录中）</p>
<p>对于replica set架构模式，只需要在每个secondary依次操作：关闭secondary，然后配置新的dbPath，然后启动即可（会执行初始化sync，从primary中将数据去完全同步到本地）。最后操作primary。</p>
<p>此参数仅对mongod进程有效，默认值为false，不建议修改此值</p>
<p>syncPeriodSecs: 60</p>
<p>描述：mongod使用fsync操作将数据flush到磁盘的时间间隔，默认值为60（单位：秒），强烈建议不要修改此值；mongod将变更的数据写入journal后再写入内存，并间歇性的将内存数据flush到磁盘中，即延迟写入磁盘，有效提升磁盘效率。此指令不影响journal存储，仅对mongod有效。</p>
<p>mmapv1:（如下配置仅对MMAPV1引擎生效）</p>
<p>quota:</p>
<p>enforced: false</p>
<p>描述：配额管理，是否限制每个DB所能持有的最大文件数量，仅对mongod有效，默认值为false，建议保持默认值。</p>
<p>maxFilesPerDB: 8</p>
<p>描述：如果enforce开启，每个DB所持有的存储文件不会超过此阀值。仅对mongod进程有效。</p>
<p>smallFiles: false</p>
<p>描述：是否使用小文件存储数据；如果此值为true，mongod将会限定每个数据文件的大小为512M（默认最大为2G），journal降低到128M（默认为1G）。如果DB的数据量较大，将会导致每个DB创建大量的小文件，这对性能有一定的影响。在production环境下，不建议修改此值，在测试时可以设置为true，节约磁盘。</p>
<p>journal:</p>
<p>commitIntervalMs: 100</p>
<p>描述：mongod进程提交journal日志的时间间隔，即fsync的间隔。考虑到磁盘效能，mongod间歇性的flush日志数据；此值越小，数据丢失的可能性越低，磁盘消耗越大，性能越低。如果希望write操作强制立即写入journal，可以传递参数选项“j:true”（在客户端write操作中指定此选项即可），此操作（包括此前尚未提交的）将会立即fsync到磁盘。仅对mongod有效，单位：毫秒</p>
<p>nsSize: 每个database的namespace文件的大小，默认为16，单位：M；最大值可以设置为2048，即dbpath下“.ns”后缀文件的大小。16M基本上可以保存24000条命名条目，新建一个collection或者index信息，即会增加一个namespace条目；如果你的database下需要创建大量的collection（比如数据分析），则可以适度调大此值。</p>
<p>wiredTiger:（如下配置仅对wiredTiger引擎生效（3.0以上版本）</p>
<p>engineConfig:</p>
<p>cacheSizeGB: 8</p>
<p>描述：wiredTiger缓存工作集（working set）数据的内存大小，单位：GB，此值决定了wiredTiger与mmapv1的内存模型不同，它可以限制mongod对内存的使用量，而mmapv1则不能（依赖于系统级的mmap）。默认情况下，cacheSizeGB的值为假定当前节点只部署一个mongod实例，此值的大小为物理内存的一半；如果当前节点部署了多个mongod进程，那么需要合理配置此值。如果mongod部署在虚拟容器中（比如，lxc，cgroups，Docker）等，它将不能使用整个系统的物理内存，则需要适当调整此值。默认值为物理内存的一半。</p>
<p>journalCompressor: snappy</p>
<p>描述：journal日志的压缩算法，可选值为“none”、“snappy”、“zlib”。</p>
<p>directoryForIndexes: false</p>
<p>描述：是否将索引和collections数据分别存储在dbPath单独的目录中。即index数据保存“index”子目录，collections数据保存在“collection”子目录。默认值为false，仅对mongod有效。</p>
<p>collectionConfig:</p>
<p>blockCompressor: snappy</p>
<p>描述：collection数据压缩算法，可选值“none”、“snappy”、“zlib”。开发者在创建collection时可以指定值，以覆盖此配置项。如果mongod中已经存在数据，修改此值不会带来问题，旧数据仍然使用原来的算法解压，新数据文件将会采用新的解压缩算法。</p>
<p>indexConfig:</p>
<p>prefixCompression: true</p>
<p>描述：是否对索引数据使用“前缀压缩”（prefix compression，一种算法）。前缀压缩，对那些经过排序的值存储，有很大帮助，可以有效的减少索引数据的内存使用量。默认值为true。</p>
<p><strong>4、operationProfiling:</strong></p>
<p>slowOpThresholdMs: 100</p>
<p>描述：数据库profiler判定一个操作是“慢查询”的时间阀值，单位毫秒；mongod将会把慢查询记录到日志中，即使profiler被关闭。当profiler开启时，慢查询记录还会被写入“system.profile”这个系统级的collection中。请参看mongod profiler相关文档。默认值为100，此值只对mongod进程有效。</p>
<p>mode: off</p>
<p>描述：数据库profiler级别，操作的性能信息将会被写入日志文件中，可选值：</p>
<p>1）off：关闭profiling</p>
<p>2）slowOp：on，只包含慢操作日志</p>
<p>3）all：on，记录所有操作</p>
<p>数据库profiling会影响性能，建议只在性能调试阶段开启。此参数仅对mongod有效。</p>
<p><strong>5、replication:</strong>（复制集架构模式配置，如果只是单点，则无需配置）</p>
<p>oplogSizeMB: 10240</p>
<p>描述：replication操作日志的最大尺寸，单位：MB。mongod进程根据磁盘最大可用空间来创建oplog，比如64位系统，oplog为磁盘可用空间的5%，一旦mongod创建了oplog文件，此后再次修改oplogSizeMB将不会生效。此值不要设置的太小， 应该足以保存24小时的操作日志，以保证secondary有充足的维护时间；如果太小，secondary将不能通过oplog来同步数据，只能全量同步。此值仅对mongod有效。</p>
<p>enableMajorityReadConcern: false</p>
<p>描述：是否开启readConcern的级别为“majority”，默认为false；只有开启此选项，才能在read操作中使用“majority”。（3.2+版本）</p>
<p>replSetName: &lt;无默认值&gt;</p>
<p>描述：“复制集”的名称，复制集中的所有mongd实例都必须有相同的名字，sharding分布式下，不同的sharding应该使用不同的replSetName。仅对mongod有效。</p>
<p>secondaryIndexPrefetch: all</p>
<p>描述：只对mmapv1存储引擎有效。复制集中的secondary，从oplog中运用变更操作之前，将会先把索引加载到内存中，默认情况下，secondaries首先将操作相关的索引加载到内存，然后再根据oplog应用操作。可选值：</p>
<p>1）none：secondaries不将索引数据加载到内容</p>
<p>2）all：sencondaries将此操作有关的索引数据加载到内存</p>
<p>3）_id_only：只加载_id索引</p>
<p>默认值为：all，此配置仅对mongod有效。</p>
<p>localPingThresholdMs: 15</p>
<p>描述：ping时间，单位：毫秒，mongos用来判定将客户端read请求发给哪个secondary。仅对mongos有效。默认值为15，和客户端driver中的默认值一样。当mongos接收到客户端read请求，它将：</p>
<p>1、找出复制集中ping值最小的member。</p>
<p>2、将延迟值被此值允许的members，构建一个列表</p>
<p>3、从列表中随机选择一个member。</p>
<p>ping值是动态值，每10秒计算一次。mongos将客户端请求转发给延迟较小（与此值相比）的某个secondary节点。仅对mongos有效。</p>
<p><strong>6、sharding:</strong>（仅对sharding架构模式下有效）</p>
<p>clusterRole: &lt;无默认值&gt;</p>
<p>描述：在sharding集群中，此mongod实例的角色，可选值：</p>
<p>1、configsvr：此实例为config server，此实例默认侦听27019端口</p>
<p>2、shardsvr：此实例为shard（分片），侦听27018端口</p>
<p>此配置仅对mongod有效。通常config server和sharding server需要使用各自的配置文件。</p>
<p>archiveMovedChunks: true</p>
<p>描述：当chunks因为“负载平衡”而迁移到其他节点时，mongod是否将这些chunks归档，并保存在dbPath下“moveChunk”目录下，mongod不会删除moveChunk下的文件。默认为true。</p>
<p>autoSplit: true</p>
<p>描述：是否开启sharded collections的自动分裂，<em>仅对mongos有效</em>。如果所有的mongos都设定为false，那么collections数据增长但不能分裂成新的chunks。因为集群中任何一个mongos进程都可以触发split，所以此值需要在所有mongos行保持一致。仅对mongos有效。</p>
<p>configDB: &lt;无默认值&gt;</p>
<p>描述：设定config server的地址列表，每个server地址之间以“,”分割，通常sharded集群中指定1或者3个config server。（生产环境，通常是3个config server，但1个也是可以的）。所有的mongos实例必须配置一样，否则可能带来不必要的问题。<em>仅对mongos有效</em>。</p>
<p>chunkSize: 64</p>
<p>描述：sharded集群中每个chunk的大小，单位：MB，默认为64，此值对于绝大多数应用而言都是比较理想的。chunkSize太大会导致分布不均，太小会导致分裂成大量的chunk而经常移动</p>
<p>##整个sharding集群中，此值需要保持一致，集群启动后修改此值将不再生效。<em>仅对mongos有效</em>。</p>
<p><strong>7、sytemsLog:</strong>（系统日志，必须配置）</p>
<p>verbosity: 0</p>
<p>描述：日志级别，0：默认值，包含“info”信息，1~5，即大于0的值均会包含debug信息</p>
<p>quiet: true</p>
<p>描述："安静"，此时mongod/mongos将会尝试减少日志的输出量。不建议在production环境下开启，否则将会导致跟踪错误比较困难。</p>
<p>traceAllExceptions: true</p>
<p>描述：打印异常详细信息。</p>
<p>path: &nbsp;logs/mongod.log</p>
<p>logAppend: false</p>
<p>描述：如果为true，当mongod/mongos重启后，将在现有日志的尾部继续添加日志。否则，将会备份当前日志文件，然后创建一个新的日志文件；默认为false。</p>
<p>logRotate: rename</p>
<p>描述：日志“回转”，防止一个日志文件特别大，则使用logRotate指令将文件“回转”，可选值：</p>
<p>1）rename：重命名日志文件，默认值。</p>
<p>2）reopen：使用linux日志rotate特性，关闭并重新打开此日志文件，可以避免日志丢失，但是logAppend必须为true。</p>
<p>destination: file</p>
<p>描述：日志输出目的地，可以指定为“ file”或者“syslog”，表述输出到日志文件，如果不指定，则会输出到标准输出中（standard output）。</p>
<p><strong>8、与安全有关的配置（摘要介绍）</strong></p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2hpZnQtYWx0LWN0cmwuaXRleWUuY29tL2ltYWdlcy9pY29uX3N0YXIucG5n.jpg"></p>
<ol>
<li>security:</li>
<li>authorization:&nbsp;enabled</li>
<li>clusterAuthMode:&nbsp;keyFile</li>
<li>keyFile:&nbsp;/srv/mongodb/keyfile</li>
<li>javascriptEnabled:&nbsp;true</li>
<li>setParameter:</li>
<li>enableLocalhostAuthBypass:&nbsp;true</li>
<li>authenticationMechanisms:&nbsp;SCRAM-SHA-1</li>
</ol>
<p>1）authorization：disabled或者enabled，仅对mongod有效；表示是否开启用户访问控制（Access Control），即客户端可以通过用户名和密码认证的方式访问系统的数据，默认为“disabled”，即客户端不需要密码即可访问数据库数据。（限定客户端与mongod、mongos的认证）</p>
<p>2）clusterAuthMode：集群中members之间的认证模式，可选值为“keyFile”、“sendKeyFile”、“sendX509”、“x509”，对mongod/mongos有效；默认值为“keyFile”，mongodb官方推荐使用x509，不过我个人觉得还是keyFile比较易于学习和使用。不过3.0版本中，mongodb增加了对TLS/SSL的支持，如果可以的话，建议使用SSL相关的配置来认证集群的member，此文将不再介绍。（限定集群中members之间的认证）</p>
<p>3）keyFile：当clusterAuthMode为“keyFile”时，此参数指定keyfile的位置，mongodb需要有访问此文件的权限。</p>
<p>4）javascriptEnabled：true或者false，默认为true，仅对mongod有效；表示是否关闭server端的javascript功能，就是是否允许mongod上执行javascript脚本，如果为false，那么mapreduce、group命令等将无法使用，因为它们需要在mongod上执行javascript脚本方法。如果你的应用中没有mapreduce等操作的需求，为了安全起见，可以关闭javascript。</p>
<p>“setParameter”允许指定一些的Server端参数，这些参数不依赖于存储引擎和交互机制，只是微调系统的运行状态，比如“认证机制”、“线程池参数”等。参见【<a href="https://docs.mongodb.org/manual/reference/parameters" rel="external nofollow noreferrer">parameter</a>】</p>
<p>1）enableLocalhostAuthBypass：true或者false，默认为true，对mongod/mongos有效；表示是否开启“localhost exception”，对于sharding cluster而言，我们倾向于在mongos上开启，在shard节点的mongod上关闭。</p>
<p>2）authenticationMechanisms：认证机制，可选值为“SCRAM-SHA-1”、“MONGODB-CR”、“PLAN”等，建议为“SCRAM-SHA-1”，对mongod/mongos有效；一旦选定了认证机制，客户端访问databases时需要与其匹配才能有效。</p>
<p><strong>9、与性能有关的参数</strong></p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2hpZnQtYWx0LWN0cmwuaXRleWUuY29tL2ltYWdlcy9pY29uX3N0YXIucG5n.jpg"></p>
<ol>
<li>setParameter:</li>
<li>connPoolMaxShardedConnsPerHost:&nbsp;200</li>
<li>connPoolMaxConnsPerHost:&nbsp;200</li>
<li>notablescan:&nbsp;0</li>
</ol>
<p>1）connPoolMaxShardedConnsPerHost：默认值为200，对mongod/mongos有效；表示当前mongos或者shard与集群中其他shards链接的链接池的最大容量，此值我们通常不会调整。连接池的容量不会阻止创建新的链接，但是从连接池中获取链接的个数不会超过此值。维护连接池需要一定的开支，保持一个链接也需要占用一定的系统资源。</p>
<p>2）connPoolMaxConnsPerHost：默认值为200，对mongod/mongos有效；同上，表示mongos或者mongod与其他mongod实例之间的连接池的容量，根据host限定。</p>
<p><strong>二、配置样例</strong></p>
<p>mongodb 3.0之后配置文件采用YAML格式，这种格式非常简单，使用&lt;key&gt;:&lt;value&gt;表示，开头使用“空格”作为缩进。需要注意的是，“:”之后有value的话，需要紧跟一个空格，如果key只是表示层级，则无需在“:”后增加空格（比如：systemLog:后面既不需要空格）。按照层级，每行4个空格缩进，第二级则8个空格，依次轮推，顶层则不需要空格缩进。如果格式不正确，将会出现如下错误：</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2hpZnQtYWx0LWN0cmwuaXRleWUuY29tL2ltYWdlcy9pY29uX3N0YXIucG5n.jpg"></p>
<ol>
<li>Error&nbsp;parsing&nbsp;YAML&nbsp;config&nbsp;file:&nbsp;yaml-cpp:&nbsp;error&nbsp;at&nbsp;line&nbsp;3,&nbsp;column&nbsp;1:&nbsp;illegal&nbsp;tab&nbsp;when&nbsp;looking&nbsp;for&nbsp;indentation</li>
<li>Error&nbsp;parsing&nbsp;YAML&nbsp;config&nbsp;file:&nbsp;yaml-cpp:&nbsp;error&nbsp;at&nbsp;line&nbsp;15,&nbsp;column&nbsp;12:&nbsp;illegal&nbsp;map&nbsp;value</li>
</ol>
<p><strong>1、mongod.conf&nbsp;</strong></p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2hpZnQtYWx0LWN0cmwuaXRleWUuY29tL2ltYWdlcy9pY29uX3N0YXIucG5n.jpg"></p>
<ol>
<li>systemLog:</li>
<li>quiet:&nbsp;false</li>
<li>path:&nbsp;/data/mongodb/logs/mongod.log</li>
<li>logAppend:&nbsp;false</li>
<li>destination:&nbsp;file</li>
<li>processManagement:</li>
<li>fork:&nbsp;true</li>
<li>pidFilePath:&nbsp;/data/mongodb/mongod.pid</li>
<li>net:</li>
<li>bindIp:&nbsp;127.0.0.1</li>
<li>port:&nbsp;27017</li>
<li>maxIncomingConnections:&nbsp;65536</li>
<li>wireObjectCheck:&nbsp;true</li>
<li>ipv6:&nbsp;false</li>
<li>storage:</li>
<li>dbPath:&nbsp;/data/mongodb/db</li>
<li>indexBuildRetry:&nbsp;true</li>
<li>journal:</li>
<li>enabled:&nbsp;true</li>
<li>directoryPerDB:&nbsp;false</li>
<li>engine:&nbsp;mmapv1</li>
<li>syncPeriodSecs:&nbsp;60</li>
<li>mmapv1:</li>
<li>quota:</li>
<li>enforced:&nbsp;false</li>
<li>maxFilesPerDB:&nbsp;8</li>
<li>smallFiles:&nbsp;true</li>
<li>journal:</li>
<li>commitIntervalMs:&nbsp;100</li>
<li>wiredTiger:</li>
<li>engineConfig:</li>
<li>cacheSizeGB:&nbsp;8</li>
<li>journalCompressor:&nbsp;snappy</li>
<li>directoryForIndexes:&nbsp;false</li>
<li>collectionConfig:</li>
<li>blockCompressor:&nbsp;snappy</li>
<li>indexConfig:</li>
<li>prefixCompression:&nbsp;true</li>
<li>operationProfiling:</li>
<li>slowOpThresholdMs:&nbsp;100</li>
<li>mode:&nbsp;off</li>
</ol>
<p>如果你的架构模式为replication Set，那么还需要在所有的“复制集”members上增加如下配置：</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2hpZnQtYWx0LWN0cmwuaXRleWUuY29tL2ltYWdlcy9pY29uX3N0YXIucG5n.jpg"></p>
<ol>
<li>replication:</li>
<li>oplogSizeMB:&nbsp;10240</li>
<li>replSetName:&nbsp;rs0</li>
<li>secondaryIndexPrefetch:&nbsp;all</li>
</ol>
<p>如果为sharding Cluster架构，则需要在shard节点增加如下配置：</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2hpZnQtYWx0LWN0cmwuaXRleWUuY29tL2ltYWdlcy9pY29uX3N0YXIucG5n.jpg"></p>
<ol>
<li>sharding:</li>
<li>clusterRole:&nbsp;shardsvr</li>
<li>archiveMovedChunks:&nbsp;true</li>
</ol>
<p>当然，一个mongod实例即可以为“复制集”的member之一，也可以作为sharding集群中的一个分片，这取决你的架构模式。</p>
<p>mongod进程可以做为“config server”实例，只需要将“clusterRole: configsvr”即可；由此可见，一个mongod实例可以为“单点实例”、“config server”、“sharding server” + “replication set member”其中一个角色，建议使用不同的配置文件启动它。</p>
<p><strong>2、mongos.conf&nbsp;</strong></p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2hpZnQtYWx0LWN0cmwuaXRleWUuY29tL2ltYWdlcy9pY29uX3N0YXIucG5n.jpg"></p>
<ol>
<li>systemLog:</li>
<li>quiet:&nbsp;false</li>
<li>path:&nbsp;/data/mongodb/logs/mongod.log</li>
<li>logAppend:&nbsp;false</li>
<li>destination:&nbsp;file</li>
<li>processManagement:</li>
<li>fork:&nbsp;true</li>
<li>pidFilePath:&nbsp;/data/mongodb/mongod.pid</li>
<li>net:</li>
<li>bindIp:&nbsp;127.0.0.1</li>
<li>port:&nbsp;37017</li>
<li>maxIncomingConnections:&nbsp;65536</li>
<li>wireObjectCheck:&nbsp;true</li>
<li>ipv6:&nbsp;false</li>
<li>replication:</li>
<li>localPingThresholdMs:&nbsp;15</li>
<li>sharding:</li>
<li>autoSplit:&nbsp;true</li>
<li>configDB:&nbsp;m1.com:27018,m2.com:27018,m3.com:27018</li>
<li>chunkSize:&nbsp;64</li>
</ol>
<p>mongos实例不需要存储实际的数据，对内存有一定的消耗，在sharding架构模式下使用；mongos需接收向客户端请求（后端的sharded和replication set则不需要让客户端知道），它可以将客户端请求转发到一个分片集群上（分片集群基于复制集）延迟相对较小的secondary上，同时还负责chunk的分裂和迁移工作。</p>
<p><strong>三、其他</strong></p>
<p><strong>1、启动与关闭</strong></p>
<p>配置文件中绝大部分参数，都可以通过进程启动命令指定，通常启动命令行中的参数将覆盖配置文件中的参数。</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2hpZnQtYWx0LWN0cmwuaXRleWUuY29tL2ltYWdlcy9pY29uX3N0YXIucG5n.jpg"></p>
<ol>
<li>./mongod&nbsp;-f&nbsp;mongod.conf</li>
</ol>
<p>当然，也可以通过使用多个命令行参数来启动，如下仅为示例：</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2hpZnQtYWx0LWN0cmwuaXRleWUuY29tL2ltYWdlcy9pY29uX3N0YXIucG5n.jpg"></p>
<ol>
<li>./mongod&nbsp;--bind_ip&nbsp;127.0.0.1&nbsp;--port&nbsp;27017&nbsp;--dbpath&nbsp;/data/mongodb/db&nbsp;--logpath&nbsp;/data/mongodb/logs&nbsp;--storageEngine&nbsp;mmapv1&nbsp;--fork</li>
</ol>
<p>mongod配置中所指定的目录地址必须首先创建，否则将无法启动，这有别与其他系统。</p>
<p>mongos启动方式同上。如果希望基于service方式启动mongod、mongos，请参考其他文档。</p>
<p>可以通过kill指令来关闭mongod进程，不过这种方式有些粗暴，在production环境中可能会导致数据损坏，建议使用mongo shell来“cleanly”关闭mongod进程，这种方式安全而且不会导致数据损坏。</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2hpZnQtYWx0LWN0cmwuaXRleWUuY29tL2ltYWdlcy9pY29uX3N0YXIucG5n.jpg"></p>
<ol>
<li>./mongo</li>
<li>&gt;&nbsp;use&nbsp;admin;</li>
<li>&gt;&nbsp;db.shutdownServer();</li>
</ol>
<p>可以使用“kill &lt;mongod process ID&gt;”的方式关闭，这种方式也是“cleanly”；如果使用“kill -9 ”方式就是强制线程退出，可能会导致数据丢失。如果在非fork下运行mongod，直接在shell上使用“CTRL-C”方式也是“cleanly”退出。对于线上环境，最好不要“kill -9”。</p>
<p><strong>2、repair</strong></p>
<p>“修复”数据库，当mongodb运行一段时间之后，特别是经过大量删除、update操作之后，我们可以使用repair指令对数据存储进行“repair”，它将整理、压缩底层数据存储文件，重用磁盘空间，相当于数据重新整理了一遍，对数据优化有一定的作用。</p>
<p>如果mongod没有开启journaling日志功能，repair指令可以在系统异常crash之后，用于整理数据、消除损坏数据；如果开启了journaling日志功能，我们则需不要使用repair来修复数据，因为journal就可以帮助mongod恢复数据。在replication set模式下，可以使用repair，但是通常可以直接删除旧数据，使用“数据同步”操作，即可达到“恢复”、“整理”数据的目的，效果和repair一样，而且效率更高。</p>
<p>repair需要磁盘有一定的剩余空间，为当前database数据量 + 2GB，可以通过使用“--repairpath”来指定repair期间存储临时数据的目录。repair指令还会重建indexes，可以降低索引的数据大小。</p>
<p>如果mongod意外crash，需要首先正常启动mongod，让根据journal日志恢复完数据之后，才能执行repair；如果journal日志有数据尚未恢复，那么使用repair指令启动mongod将会失败。</p>
<p>repair时需要关闭mongod进程，执行完毕后再启动。</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2hpZnQtYWx0LWN0cmwuaXRleWUuY29tL2ltYWdlcy9pY29uX3N0YXIucG5n.jpg"></p>
<ol>
<li>./mongod&nbsp;--dbpath=/data/mongodb/db&nbsp;--repair</li>
</ol>
<p>mongodb比较倾向于使用shell来repair特定的database，这个操作相对比较可控，其内部工作机制一样。</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2hpZnQtYWx0LWN0cmwuaXRleWUuY29tL2ltYWdlcy9pY29uX3N0YXIucG5n.jpg"></p>
<ol>
<li>&gt;./mongo</li>
<li>&gt;user&nbsp;mydatabase;</li>
<li>&gt;db.repairDatabase();</li>
</ol>
<p><strong>3、mongodump与mongorestore</strong></p>
<p>我们通常会使用到mongodb数据的备份功能，或者将一个备份导入到一个新的mongod实例中（数据冷处理），那么就需要借助这两个指令。</p>
<p>mongodump将整个databases全部内容导出到一个二进制文件中，可以在其他mongod使用mongorestore来加载整个文件。需要注意mongodump不会导出“local”数据库中的数据，当然这个local库对恢复数据也没有太大意义。</p>
<p>“-u”参数指定访问database的用户名，“-p”指定密码，“--host”和“--port”指定mongod实例的位置，“--db”指定需要dump的数据库，如果不指定则dump所有数据库，“--collection”指定需要dump的集合表，如果不指定则dumpl整个db下的所有collections；“--query &lt;json&gt;”指定dump时的查询条件，“--out”指定结果输出文件的路径：</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2hpZnQtYWx0LWN0cmwuaXRleWUuY29tL2ltYWdlcy9pY29uX3N0YXIucG5n.jpg"></p>
<ol>
<li>&gt;./mongodump&nbsp;--host&nbsp;m1.com&nbsp;--port&nbsp;27017&nbsp;-u&nbsp;root&nbsp;-p&nbsp;pass&nbsp;--out&nbsp;/data/mongodb/backup/dump_2015_10_10</li>
</ol>
<p>mongorestore则将dump的数据文件导入到database，mongorestore可以创建新的database或者将数据添加到现有的database中。如果将数据restore到已经存在的database中，mongorestore仅执行insert，不会执行update，如果数据库中已经存在相同的“_id”数据，mongorestore不会覆盖原有的document。mongorestore会重新创建indexes，所有的操作都是insert而不会update。</p>
<p>基本指令类似于mongodump，“--db”指定需要将数据restore到哪个db中，如果此db不存在，则创建；如果没有指定“--db”，mongorestore则根据原始数据所属的db重新创建，这可能会导致数据覆盖。“--drop”表示在restore数据之前，首先删除目标db中原有的collections，--drop不会删除那些在dump文件中没有的collection。“--stopOnError”表示出错时强制退出。</p>
<p>Java代码&nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc2hpZnQtYWx0LWN0cmwuaXRleWUuY29tL2ltYWdlcy9pY29uX3N0YXIucG5n.jpg"></p>
<ol>
<li>./mongorestore&nbsp;--db&nbsp;mydatabase&nbsp;/data/mongodb/backup/dump_2015_10_10</li>
</ol>
<p><strong>4、mongoimport和mongoexport</strong></p>
<p>mongoexport将数据导出为JSON或者CSV格式，以便其他应用程序解析。</p>
<p>因为mongodb数据是BSON格式，有些数据类型是JSON不具有的，所以导出JSON格式会仍然会丢失数据类型；所以如果导出的数据是准备给其他mongodb恢复数据，那么建议使用mongodump和mongorestore。</p>
<p>命令参数同3）</p>
<p><strong>5、mongostat</strong>指令可以间歇性的打印出当前mongod实例中“数据存储”、“flush”、读写次数、网络输出等参数，是查看mongod性能的有效手段。mongotop可以根据查看各个database下读写情况。</p>
<p>更多关于mongodb的运维操作，稍后介绍。</p>
<p><strong>6、mongo shell操作简述</strong>：</p>
<p>1）help：列出所有的function</p>
<p>2）show dbs：展示当前实例中所有的databases。</p>
<p>3）use &lt;dbname&gt;：切换到指定的db，接下来的操作将会在此db中。</p>
<p>4）show collections：展示出当前db中所有的collections。</p>
<p>5）show users：展示当前db中已经添加的所有用户。</p>
<p>6）show roles：展示当前db中所有内置的或者自定义的用户角色。</p>
<p>7）show profile：这涉及到profile相关的配置，默认情况下展示出最近5个操作耗时超过1秒的操作，通常用于跟踪慢查询。</p>
<p>8）db.help()：展示出可以在db上进行的操作function。</p>
<p>9）db.&lt;collection&gt;.help()：展示出可以在colleciton上进行的操作。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 04:56:35 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/hold/" title="hold">hold</a>, <a href="https://www.biecuoliao.com/tag/inux/" title="inux">inux</a>, <a href="https://www.biecuoliao.com/tag/%e8%bf%81%e7%a7%bb/" title="迁移">迁移</a>, <a href="https://www.biecuoliao.com/tag/%e7%a4%ba%e4%be%8b/" title="示例">示例</a>, <a href="https://www.biecuoliao.com/tag/auth/" title="auth">auth</a>, <a href="https://www.biecuoliao.com/tag/%e5%8c%b9%e9%85%8d/" title="匹配">匹配</a>, <a href="https://www.biecuoliao.com/tag/%e8%bf%98%e9%9c%80%e8%a6%81/" title="还需要">还需要</a>, <a href="https://www.biecuoliao.com/tag/off/" title="off">off</a>, <a href="https://www.biecuoliao.com/tag/%e4%b8%8d%e5%bf%85%e8%a6%81/" title="不必要">不必要</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>mongodb 配置文件解释(转)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0koAP70.html" rel="bookmark">mongodb配置文件的英文翻译</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mongod.conf,版本3.2,个人英语能力有限,结合翻译软件,大致翻译如下: ## 日志选项 systemLog: verbosity: &lt;int&gt; # 默认是0 ,1到5的增长代表了,错误信息的描述程度,数越大,描述越详细 quiet: &lt;boolean&gt; #这个后面要写1,不建议在生产模式开启这个参数.这个后跟布尔值,进入mongo时是否会系那是相应的登陆信息,最好是让他可以提供你登录的时候会显示的信息,这样有利于规避错误 traceAllExceptions: &lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vZxyZ3.html" rel="bookmark">haproxy配置文件解释</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				haproxy配置文件各项解释 ####################全局配置信息######################## #######参数是进程级的,通常和操作系统(OS)相关######### global log 127.0.0.1 local0 info      #日志格式 chroot /var/haproxy              #chroot运行的路径 group haproxy                   #所属运行的用户 user haproxy  			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n7R9P3.html" rel="bookmark">MongoDB配置文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				常用的配置方式: #server############################# dbpath = /usr/local/mongodb/mongodb/data logpath = /usr/local/mongodb/mongodb/log/mongod.log pidfilepath = /usr/local/mongodb/mongodb/mongod.pid #append log logappend = true fork = true port = 27017 journ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Ol78Z4.html" rel="bookmark">【转】MongoDB配置文件说明</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				启动MongoDB有2种方式,一是直接指定配置参数,二是指定配置文件.这里先介绍配置文件,启动方式如下: mongod --config /etc/mongodb.conf 配置如下: verbose:日志信息冗余.默认false.提高内部报告标准输出或记录到logpath配置的日志文件中.要启用verbose或启用verbosity 用vvvv参数,如: verbose = true vvvv = true ps:启动verbose冗长信息,它的级别有 vv~vvvvv,v越多级别越高,在日志			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qPVlN0.html" rel="bookmark">springmvc 注解 配置文件解释</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 继 Spring 2.0 对 Spring MVC 进行重大升级后,Spring 2.5 又为 Spring MVC 引入了注解驱动功能.现在你无须让 Controller 继承任何接口,无需在 XML 配置文件中定义请求和 Controller 的映射关系,仅仅使用注解就可以让一个 POJO 具有 Controller 的绝大部分功能 —— Spring MVC 框架的易用性得到了进一步的增强.在框架灵活性.易用性和扩展性上,Spring MVC 已经全面超越了其它的 MVC 框架,伴随			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/ME2n2D0.html" rel="bookmark">【配置】MongoDB配置文件详细配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				# 数据文件位置 dbpath = /opt/module/mongoData # 日志文件位置 logpath = /opt/module/mongoLog/mongodb.log # 以追加方式写入日志,true为追加.false是覆盖 logappend = true # 日志输出都发送到主机的syslog系统,而不是标准输出到logpath指定日志文件.syslog和logpath不能一起用,会报错:Cant use both a logpath and syslog # syslog			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4A6zX5M.html" rel="bookmark">haproxy配置文件解释&lpar;三&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				网上找的..抽空在看看 HAProxy的配置HAProxy配置中分成五部分内容,当然这些组件不是必选的,可以根据需要选择部分作为配置.global:参数是进程级的,通常和操作系统(OS)相关.这些参数一般只设置一次,如果配置无误,就不需要再次配置进行修改defaults:配置默认参数的,这些参数可以被利用配置到frontend,backend,listen组件frontend:接收请求的前端虚拟节点,Frontend可以根据规则直接指定具体使用后端的      backend(可动态选择).ba			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pQjGyM.html" rel="bookmark">Hibernate配置文件解释</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Hibernate配置文件主要用于配置数据库连接和Hibernate运行时所需的各种属性每个Hibernate配置文件对应一个Configuration对象Hibernate配置文件可以有两种格式: hibernate.properties hibernate.cfg.xml----常用 Hibernate.cfg.xml的常用属性 JDBC连接属性 connection.url:数据库url connection.username:数据库用户名 connection.password:数据库用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OymOgM.html" rel="bookmark">&lbrack;分享&rsqb; 封装工具ES4配置文件解释</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				LiQiang 发表于 2015-2-3 14:41:21 https://www.itsk.com/thread-346132-1-4.html 本帖最后由 LiQiang 于 2015-2-3 14:52 编辑 本帖隐藏的内容 ComputerName=qiang计算机名前缀ResDesktop=1024x768分辨率设置ResRefresh=Default赫兹设置[Network]网络选择设置IpMode=DHCPNet=WorkGroupWorkGroup=WorkGroup工作组Net			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/v0kxm73.html" rel="bookmark" class="title">（6）javascript的程序控制结构及语句-----（1）条件判断</a>
					<div>
						程序控制结构及语句 编程就是将现实应用,转换为程序能够读得懂的语法语句.Javascript编程中对程序流程控制主要是通过条件判断语句.循环控制语句及continue.break来完成的,其中条件判断 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47pVV9M.html" rel="bookmark" class="title">由于执行触发器&comma;登录名 &amp;&num;39&semi;sa&amp;&num;39&semi; 的登录失败</a>
					<div>
						使用触发器限制数据库连接IP 如: USE master GO if exists (select * from sysobjects where name = 'tr_LoginCheck' and ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZV8Lg3.html" rel="bookmark" class="title">JAVA IO操作：数据操作流：DataOutputStream和DataInputStream</a>
					<div>
						掌握DataOutputStream和DataInputStream的作用. 可以使用DataOutputStream和DataInputStream写入和读取数据. 在IO包中提供了两个与平台无关的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLDrjWM.html" rel="bookmark" class="title">烂泥：数据库管理之phpmyadmin免密码配置</a>
					<div>
						本文由ilanniweb提供友情赞助,首发于烂泥行天下 想要获得更多的文章,可以关注我的微信ilanniweb 其实这篇文章很早就想写了,但是一直没有时间.刚好今天下午稍微空了点,就把这篇文章整理出来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZYG7Z0.html" rel="bookmark" class="title">C&lpar;&plus;&plus;&rpar; web实时消息服务器后台推送技术方案---GoEasy</a>
					<div>
						Goeasy, 它是一款第三方推送服务平台,使用它的API可以轻松搞定实时推送!个人感觉goeasy推送更稳定,推送速度快,代码简单易懂上手快浏览器兼容性:GoEasy推送支持websocket 和p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eqGap0.html" rel="bookmark" class="title">从HTTP到JDBC完整访问路径日志实现思路</a>
					<div>
						一个部署在TOMCAT的WEB系统,需要采集到完整访问路径的日志信息,这些信息包括:客户端IP.WEB服务器IP.被调用的JAVA方法.执行的SQL语句.特别在应用程序配置了数据库连接池的情况下,这条 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBA6bK4.html" rel="bookmark" class="title">Proc 编程</a>
					<div>
						一.简介 Proc文件系统是Linux系统上的一种伪文件系统(也即虚拟文件系统),存储的是当前内核运行状态的一系列特殊文件,用户可以通过这些文件查看有关系统硬件及当前正在运行进程的信息,甚至可以通过更 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVYGZk4.html" rel="bookmark" class="title">java中import、package作用和用法</a>
					<div>
						  有些人写了一阵子 Java,可是对於 Java 的 package 跟 import 还是不 太了解很多人以為原始码 .java 档案中的 import 会让编译器把所 import 的程式通通写 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47DleRM.html" rel="bookmark" class="title">Android 依赖注入</a>
					<div>
						Dagger2 ![https://github.com/google/dagger](github托管地址) 1. 安装依赖: ``` compile 'com.google.dagger:dagg ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47DxdkM.html" rel="bookmark" class="title">jsp&amp;lt&semi;base&amp;gt&semi;语句</a>
					<div>
						String path = req.getContextPath();//返回的是项目的根目录  /ssh req.getScheme();//返回的是当前页面服务器的协议: http 或是https ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pzRRV0.html" rel="bookmark" class="title">Android基础--单元测试框架</a>
					<div>
						1.定义一个类继承AndroidTestCase,在类中定义方法,选中方法,右键,RunAs--&gt;Android Junit Test即可测试方法的运行,无需界面跳转等复杂操作. public  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEvL2D0.html" rel="bookmark" class="title">Eecel 开发备忘</a>
					<div>
						1.装完读取插件才可以对EXCEL读取 Excel 2010 读取数据插件 https://www.microsoft.com/zh-CN/download/details.aspx?id=13255 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j15vAM.html" rel="bookmark" class="title">再回首Java第十九天</a>
					<div>
						类加载机制 JVM的类加载机制主要有一下三种加载机制 全盘负责:所谓全盘负责就是说当一个类加载器负责加载某个Class的时候,该Class所依赖和引用的其它的Class都由该类加载器负责加载,除非显式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dN2lz4.html" rel="bookmark" class="title">Review of Arterki-High-leverage side- combination plier&period;</a>
					<div>
						I am a lazy guy, but my brother is just opposite to what I am. He is always passionate about his bac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVqbvz4.html" rel="bookmark" class="title">CC150 4&period;4</a>
					<div>
						4.4 Given a binary search tree, design an algorithm which creates a linked list of all the nodes at  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kNYnlM.html" rel="bookmark" class="title">利用css实现页面加载时旋转动画</a>
					<div>
						有时浏览一些网站时在刚加载页面时候会出现一个滚动动画如下图,特别是对于一些移动端的站点或者混合应用来说应该用户体验会好很多,扒了下页面发现是用css样式控制的,于是把页面以及css样式赋值了下来, h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OpwyK4.html" rel="bookmark" class="title">Android 获取全部应用</a>
					<div>
						  private PackageManager mPackageManager;   //获取系统应用mPackageManager = getActivity().getPackageManage ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgYzp83.html" rel="bookmark" class="title">新手学习之路01-创建项目开始</a>
					<div>
						新手学习之路01-创建项目开始 小菜鸟准备学习RN开发,决定写下自己的学习历程,方便其他也想要学习RN的人,后期会持续更新写下自己所有学习经历,一步步从菜鸟成长成业内高手.开发环境准备,本文默认环境已 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02oAOa3.html" rel="bookmark" class="title">HTML排版</a>
					<div>
						HTML排版总结 浏览器使用流在页面中放置元素. 块元素从上向下流 , 各元素之间有一 个换行. 默认的,每个块元素会占浏览器窗口的整个宽度. 内联元素在块元素内部从左上方流向右下方. 如果需要多行  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QPE6E3.html" rel="bookmark" class="title">Lattice Diamond 的学习之新建工程</a>
					<div>
						1).打开软件 在软件打开后的初始布局会有一个Start  page 可以创建.打开.导入一个ISPLEVER 工程. 2).建立工程:1,Start page 中Project --&gt; NEW ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
